/*
 * socket.c
 *
 * Copyright 2005, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 */


#include<config.h>
#include<types.h>
#include<errno.h>
#include<mm.h>
#include<lock.h>
#include<net/net.h>


/*
 * GLOBAL
 * IPХåեդ
 * parameters : IPѥå,IPХåեݥ
 * return : 0 ot error number
 */
int allocIpBuf(IP_HEADER *ip,IP_BUFFER **pipbuf)
{
	int ip_size = swapWord(ip->len);
	IP_BUFFER *ipbuf;
	
	
	/* Хåեγդ */
	ipbuf = kmalloc(sizeof(IP_BUFFER) + ip_size - sizeof(IP_HEADER));
	if (ipbuf == NULL)
		return -ENOMEM;
	memcpy(&ipbuf->ip,ip,ip_size);
	ipbuf->next = NULL;
	ipbuf->offset = 0;
	ipbuf->access = 0;
	*pipbuf = ipbuf;
	
	return 0;
}


/*
 * GLOBAL
 * ԤХåե³
 * parameters : å,Хåե
 */
void addRecvBuf(SOCKET *sc,IP_BUFFER *ipbuf)
{
	IP_BUFFER **p;
	
	
	enter_spinlock(&sc->lockGate);
	{
		/* IPإåμֹ³ */
		for (p = &sc->recvBuf; *p != NULL; p = &(*p)->next)
			if (ipbuf->ip.id < (*p)->ip.id)
				break;
		ipbuf->next = *p;
		*p = ipbuf;
	}
	exit_spinlock(&sc->lockGate);
}


/*
 * GLOBAL
 * ԤХåեФ
 * parameters : å,Хåե
 * return : ipbuf or NULL
 */
IP_BUFFER *removeRecvBuf(SOCKET *sc)
{
	IP_BUFFER *ipbuf;
	
	
	enter_spinlock(&sc->lockGate);
	{
		ipbuf = sc->recvBuf;
		sc->recvBuf = ipbuf->next;
	}
	exit_spinlock(&sc->lockGate);
	
	return ipbuf;
}


/*
 * GLOBAL
 * ԤХåե󥯺
 * parameters : å,Хåե
 */
void delRecvBuf(SOCKET *sc,IP_BUFFER *ipbuf)
{
	IP_BUFFER **p;
	
	
	enter_spinlock(&sc->lockGate);
	{
		for (p = &sc->recvBuf; *p != NULL; p = &(*p)->next)
			if (*p == ipbuf)
			{
				*p = ipbuf->next;
				break;
			}
	}
	exit_spinlock(&sc->lockGate);
}


/*
 * GLOBAL
 * ǽμԤХåե򻲾Ȥ
 * parameters : å,Хåե
 */
IP_BUFFER *referRecvBuf(SOCKET *sc)
{
	return sc->recvBuf;
}
